<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'"
				 label-width="160px" @submit.native.prevent>
			<el-divider content-position="left"><i class="el-icon-document"></i>
				基本信息
			</el-divider>
			<el-row  :gutter="15">
				<el-col :span="12">
					<el-form-item label="姓名" prop="creatName"
								  :rules="[]">
						<el-input v-model="inputForm.createName" :disabled="true" ></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="部门" prop="officeName"
								  :rules="[]">
						<el-input v-model="inputForm.officeName" :disabled="true" ></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="离职时间" prop="dimissionDate"
								  :rules="[
								  {required: true, message:'离职时间不能为空', trigger:'blur'}]">
						<el-date-picker
							style="width: 100%"
							v-model="inputForm.dimissionDate"
							type="date"
							format="YYYY-MM-DD"
							value-format="YYYY-MM-DD"
							placeholder="选择日期"
							@change="checkTime"
						/>
					</el-form-item>
				</el-col>
				<el-col :span="24">
					<el-form-item label="离职原因" prop="reason"
								  :rules="[{required: true, message:'离职原因不能为空', trigger:'blur'}]">
						<el-input :disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" type="textarea" placeholder="请输入原因"  maxlength="500"  style="width:100%" v-model="inputForm.reason" show-word-limit></el-input>
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
		<UpLoadComponent ref="uploadComponent"></UpLoadComponent>

	</div>
</template>

<script>
	import XEUtils from 'xe-utils'
	import DimissionService from '@/api/jy/DimissionService'
	import { ElDatePicker } from 'element-plus';
	import UserSelectSignatory from '../workClientInfo/clientUserSelect'
	import UpLoadComponent from '@/views/common/UpLoadComponent'
	import CommonApi from '@/api/cw/common/CommonApi'
	import SelectTree from '@/components/treeSelect/treeSelect.vue'
	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				loading: false,
				inputForm: {
					id: '',
					createName:this.$store.state.user.name,
					officeName:this.$store.state.user.office.name,
					dimissionDate:'',
					reason: '',
					files: [], // 附件信息
					procInsId: '',

				},
				baseKey: '',
				keyWatch: '',
				dateList:[],
				programRow:'',
				days:'',

			}
		},
		DimissionService:null,
		commonApi: null,
		created () {
			this.dimissionService=new DimissionService()
			this.commonApi = new CommonApi()
		},
		mounted () {
		},
		activated () {
		},
		components: {
			ElDatePicker,
			UserSelectSignatory,
			UpLoadComponent,
			SelectTree,
		},
		computed: {
			bus: {
				get () {
					this.$refs.uploadComponent.setDividerName('附件')
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					console.log('几里路')
					if (this.bus) {
						if (this.bus !== 'false') {
							this.init('', this.bus)
						}
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
					this.$refs.uploadComponent.changeLoading(newVal)
				}
			}
		},
		methods: {
			getKeyWatch(keyWatch) {
				this.keyWatch = keyWatch
			},
			init(method, id) {
				this.method = method
				this.inputForm={
					id: '',
					createName:'',
					officeName:'',
					dimissionDate:'',
					reason: '',
					files: [], // 附件信息
					procInsId: '',
				}
				this.inputForm.id = id
				this.loading = false
				this.$nextTick(() => {
					this.$refs.inputForm.resetFields()
					this.loading = true
					this.$refs.uploadComponent.clearUpload()
					if (this.commonJS.isNotEmpty(this.inputForm.id)) {
						console.log('this.inputForm.id', this.inputForm.id)
						this.dimissionService.queryById(this.inputForm.id).then((data)=>{
							this.inputForm = this.recover(this.inputForm, data)
							this.days=data.days
							this.inputForm.files=data.files
							console.log('s',this.inputForm)
							if (this.status === 'audit' || this.status === 'taskFormDetail') {
								method = 'view'
							}
							console.log('me',method)
							this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'jyHoliday',null,null,null,null,null)
							this.loading = false
						})

					}
				})
			},
			saveForm(callback) {
				this.doSubmit('save', callback)
			},
			startForm(callback) {
				this.loading = true
				if (this.commonJS.isNotEmpty(this.inputForm.id)) {
					this.dimissionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '0' && data.status !== '1' && data.status !== '3') { // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							this.doSubmit('start', callback)
						}
					})
				} else {
					this.doSubmit('start', callback)
				}
			},
			async agreeForm(callback) {
				console.log('进入方法')
				this.loading = true
				await this.dimissionService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '2' ) { // status的值不等于“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error()
					} else {
						this.inputForm.status= '2'
							this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((da)=>{
								if (this.commonJS.isNotEmpty(da)) {
									if (da === '公司领导审核') {
										this.inputForm.status = '5'
									}
								}
								let param = {status: this.inputForm.status, id: this.inputForm.id}
								this.inputForm=JSON.stringify(this.inputForm)
								this.dimissionService.saveForm(this.inputForm).then(() => {
									callback(data.businessTable, data.businessId, this.inputForm,data.days)
									this.loading = false
								}).catch(() => {
									this.loading = false
								})
							})
					}
				})
			},
			reapplyForm(callback) {
				this.loading = true
				this.dimissionService.queryById(this.inputForm.id).then((data) => {
					if (data.status !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.doSubmit('reapply', callback)
					}
				})
			},
			// 表单提交
			async doSubmit(status, callback) {
				this.loading = true
				console.log('5',this.inputForm)
				if (status === 'save') {
					// 暂存
					this.loading = true
					this.inputForm.status = '1'
					if (this.$refs.uploadComponent.checkProgress()) {
						this.loading = false
						return
					}
					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					this.dimissionService.saveForm(this.inputForm).then((data) => {
						callback(data.businessTable, data.businessId, this.inputForm,data.days)
						this.loading = false
					}).catch(() => {
						this.loading = false
					})
					return
				} else if (status === 'start') {

					if (this.commonJS.isEmpty(this.inputForm.dimissionDate)){
						this.$message.error('请选择离职时间')
						this.loading = false
					}
					if (this.commonJS.isEmpty(this.inputForm.reason)){
						this.$message.error('请输入离职原因')
						this.loading = false
					}
					if (this.$refs.uploadComponent.checkProgress()) {
						this.loading = false
						return
					}
					this.inputForm.files = this.$refs.uploadComponent.getDataList()
					// 送审  待审核
					this.inputForm.status = '2'
				} else if (status === 'agree') {
					this.inputForm.status= '5'
				} else if (status === 'reapply') {
					this.inputForm.status = '2'
				}
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true
						console.log('form',this.inputForm)
						this.inputForm=JSON.parse(JSON.stringify(this.inputForm))
						this.dimissionService.saveForm(this.inputForm).then((data) => {
							callback(data.businessTable, data.businessId, this.inputForm)
							this.$refs.inputForm.resetFields()
							this.loading = false
						}).catch(() => {
							this.$refs.inputForm.resetFields()
							this.loading = false
						})
					} else {
						this.loading = false
					}
				})
			},
			close() {
				this.inputForm = {
					id:'',
					projectList:[],
					name:'',
					no:'',
					projectLeader:'',
					projectCreateDate:'',
					createById:'',
					createByName:'',
					createDate:'',
					remarks:'',
					files: [], // 附件信息
					types:[], //用印类型
					number:'', //用印份数
					projectId:'',
				}
				this.visible = false
			},
			async updateStatusById(type, callback) {
				this.loading = true
				if (type === 'reject' || type === 'reback') {
					this.dimissionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// if (type === 'agree') {
							//   // 同意
							//   this.inputForm.status = '5'
							// }
							if (type === 'reject') {
								// 驳回
								this.inputForm.status = '4'
							}
							if (type === 'reback') {
								// 撤回
								this.inputForm.status = '3'
							}
							if (type === 'reject' || type === 'reback') {
								let param = {status: this.inputForm.status, id: this.inputForm.id}
								this.dimissionService.updateStatusById(param).then(() => {
									this.loading = false
									callback()
								})
							}
						}
					})
				} else if (type === 'hold') {
					this.dimissionService.queryById(this.inputForm.id).then((data) => {
						if (data.status !== '4') { // status的值不等于“驳回”就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error()
						} else {
							// 终止
							let param = {status: '1', id: this.inputForm.id}
							this.dimissionService.updateStatusById(param).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}

			},

		}

	}
</script>
<style scoped>
	/deep/ .el-input-number .el-input__inner {
		text-align: left;
	}
	/deep/ .vxe-footer--row .vxe-footer--column:nth-child(1) .vxe-cell--item {
		font-weight:700;
	}
</style>
